'''
Created on Jul 16, 2013

@author: Jose Antonio Sal y Rosas Celi
@contact: arturo.jasyrc@gmail.com

As imported and slightly modified by Bill Rideout Jan 20, 2015

$Id: urls.py 7246 2020-10-12 14:54:26Z brideout $
'''

from django.conf.urls import url
from . import views

urlpatterns = [        url(r'^$',
                           views.index,
                           name='index'),
                       url(r'^index.html/?$',
                           views.index,
                           name='index'),
                       url(r'^single/?$',
                           views.check_registration(views.view_single),
                           name='view_single'),
                       url(r'^register/?$',
                           views.view_registration,
                           name='view_registration'),
                       url(r'^getCategories/?$',
                           views.get_categories,
                           name='get_categories'),
                       url(r'^getInstruments/?$',
                           views.get_instruments,
                           name='get_instruments'),
                       url(r'^getYears/?$',
                           views.get_years,
                           name='get_years'),
                       url(r'^getMonths/?$',
                           views.get_months,
                           name='get_months'),
                       url(r'^getCalendar/?$',
                           views.get_calendar,
                           name='get_calendar'),
                       url(r'^populateCalendarExperiment/?$',
                           views.populate_calendar_experiment,
                           name='populate_calendar_experiment'),
                       url(r'^getFiles/?$',
                           views.get_files,
                           name='get_files'),
                       url(r'^changeFiles/?$',
                           views.change_files,
                           name='change_files'),
                       url(r'^showPlots/?$',
                           views.show_plots,
                           name='show_plots'),
                       url(r'^downloadAsIs/?$',
                           views.download_as_is,
                           name='download_as_is'),
                       url(r'^downloadFileAsIs/?$',
                           views.download_file_as_is,
                           name='download_file_as_is'),
                       url(r'^printAsIs/?$',
                           views.print_as_is,
                           name='print_as_is'),
                       url(r'^listRecords/?$',
                           views.list_records,
                           name='list_records'),
                       url(r'^showInfo/?$',
                           views.show_info,
                           name='show_info'),
                       url(r'^showDoi/?$',
                           views.show_doi,
                           name='show_doi'),
                       url(r'^getAdvanced/?$',
                           views.get_advanced,
                           name='get_advanced'),
                       url(r'^advancedDownload/?$',
                           views.advanced_download,
                           name='advanced_download'),
                       url(r'^advancedPrint/?$',
                           views.advanced_print,
                           name='advanced_print'),
                       url(r'^list/?$',
                           views.check_registration(views.view_list),
                           name='view_list'),
                       url(r'^downloadAsIsScript/?$',
                           views.download_as_is_script,
                           name='download_as_is_script'),
                       url(r'^generateDownloadFilesScript/?$',
                           views.generate_download_files_script,
                           name='generate_download_files_script'),
                       url(r'^downloadAdvancedScript/?$',
                           views.download_advanced_script,
                           name='download_advanced_script'),
                       url(r'^generateDownloadAdvancedScript/?$',
                           views.generate_download_advanced_script,
                           name='generate_download_advanced_script'),
                       url(r'^generateParmsScript/?$',
                           views.generate_parms_script,
                           name='generate_parms_script'),
                       url(r'^generateParmsFiltersScript/?$',
                           views.generate_parms_filters_script,
                           name='generate_parms_filters_script'),
                       url(r'^listExperiments/?$',
                           views.list_experiments,
                           name='list_experiments'),
                       url(r'^viewRecordPlot/?$',
                           views.view_record_plot,
                           name='view_record_plot'),
                       url(r'^viewRecordImage/?$',
                           views.view_record_image,
                           name='view_record_image'),
                       url(r'^showExperiment/?$',
                           views.check_registration(views.show_experiment),
                           name='show_experiment'),
                       url(r'^madExperiment.cgi/*$',
                           views.check_registration(views.show_experiment_v2),
                           name='show_experiment_v2'),
                       url(r'^chooseScript/?$',
                           views.check_registration(views.choose_script),
                           name='choose_script'),
                       url(r'^ftp/$',
                           views.check_registration(views.ftp),
                           name='ftp'),
                       url(r'^ftp/fullname/([^/]+)/email/([^/]+)/affiliation/([^/]+)/kinst/(\d+)/$',
                           views.ftp_instrument,
                           name='ftp_instrument'),
                       url(r'^ftp/fullname/([^/]+)/email/([^/]+)/affiliation/([^/]+)/kinst/(\d+)/year/(\d+)/$',
                           views.ftp_year,
                           name='ftp_year'),
                       url(r'^ftp/fullname/([^/]+)/email/([^/]+)/affiliation/([^/]+)/kinst/(\d+)/year/(\d+)/kindat/(\d+)/$',
                           views.ftp_kindat,
                           name='ftp_kindat'),
                       url(r'^ftp/fullname/([^/]+)/email/([^/]+)/affiliation/([^/]+)/kinst/(\d+)/year/(\d+)/kindat/(\d+)/format/([^/]+)/$',
                           views.ftp_files,
                           name='ftp_files'),
                       url(r'^ftp/fullname/([^/]+)/email/([^/]+)/affiliation/([^/]+)/kinst/(\d+)/year/(\d+)/kindat/(\d+)/format/([^/]+)/fullFilename/([^/]+)/$',
                           views.ftp_download,
                           name='ftp_download'),
                       url(r'ftpMultipleDownload/$',
                           views.ftp_multiple_download,
                           name='ftp_multiple_download'),
                       url(r'^instMetadata/?$',
                           views.instrument_metadata,
                           name='instrument_metadata'),
                       url(r'^siteMetadata/?$',
                           views.site_metadata,
                           name='site_metadata'),
                       url(r'^parameterMetadata/?$',
                           views.parameter_metadata,
                           name='parameter_metadata'),
                       url(r'^kindatMetadata/?$',
                           views.kindat_metadata,
                           name='kindat_metadata'),
                       url(r'^madCalculator/?$',
                           views.madrigal_calculator,
                           name='madrigal_calculator'),
                       url(r'^madCalculatorOutput/?$',
                           views.madrigal_calculator_output,
                           name='madrigal_calculator_output'),
                       url(r'^getMetadata/*$',
                           views.get_metadata,
                           name='get_metadata'),
                       url(r'^looker/?$',
                           views.looker_main,
                           name='looker_main'),
                       url(r'^lookerForm/?$',
                           views.looker_form,
                           name='looker_form'),
                       url(r'^lookerOutput/?$',
                           views.looker_output,
                           name='looker_output'),
                       url(r'^getVersionService.py/*$',
                           views.get_version_service,
                           name='get_version_service'),
                       url(r'^getInstrumentsService.py/*$',
                           views.get_instruments_service,
                           name='get_instruments_service'),
                       url(r'^getExperimentsService.py/*$',
                           views.get_experiments_service,
                           name='get_experiments_service'),
                       url(r'^getExperimentFilesService.py/*$',
                           views.get_experiment_files_service,
                           name='get_experiment_files_service'),
                       url(r'^getParametersService.py/*$',
                           views.get_parameters_service,
                           name='get_parameters_service'),
                       url(r'^isprintService.py/*$',
                           views.isprint_service,
                           name='isprint_service'),
                       url(r'^getMadfile.cgi/*$',
                           views.get_madfile_service,
                           name='get_madfile_service'),
                       url(r'^madCalculatorService.py/*$',
                           views.mad_calculator_service,
                           name='mad_calculator_service'),
                       url(r'^madTimeCalculatorService.py/*$',
                           views.mad_time_calculator_service,
                           name='mad_time_calculator_service'),
                       url(r'^madCalculator2Service.py/*$',
                           views.mad_calculator2_service,
                           name='mad_calculator2_service'),
                       url(r'^madCalculator2Service.py',
                           views.mad_calculator2_service,
                           name='mad_calculator2_service'),
                       url(r'^madCalculator3Service.py/*$',
                           views.mad_calculator3_service,
                           name='mad_calculator3_service'),
                       url(r'^madCalculator3Service.py',
                           views.mad_calculator3_service,
                           name='mad_calculator3_service'),
                       url(r'^geodeticToRadarService.py',
                           views.geodetic_to_radar_service,
                           name='geodetic_to_radar_service'),
                       url(r'^radarToGeodeticService.py',
                           views.radar_to_geodetic_service,
                           name='radar_to_geodetic_service'),
                       url(r'^listFileTimesService.py',
                           views.list_file_times_service,
                           name='list_file_times_service'),
                       url(r'^downloadWebFileService.py',
                           views.download_web_file_service,
                           name='download_web_file_service'),
                       url(r'^traceMagneticFieldService.py',
                           views.trace_magnetic_field_service,
                           name='trace_magnetic_field_service'),
                       url(r'^globalFileSearchService.py',
                           views.global_file_search_service,
                           name='global_file_search_service'),
                       url(r'^getUrlListFromGroupIdService.py',
                           views.get_url_list_from_group_id_service,
                           name='get_url_list_from_group_id_service'),
                       url(r'^setGroupIdFromUrlListService.py',
                           views.set_group_id_from_url_list_service,
                           name='set_group_id_from_url_list_service'),
                       url(r'docs/name/(.+)$',
                           views.docs,
                           name='docs'),
                       
                    ]

